Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -3439,8 +3462,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_VINCENT_PROTOCOL == 1
 
 #if IRMP_SUPPORT_METZ_PROTOCOL == 1
-                    if (irmp_pulse_time >= METZ_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= METZ_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= METZ_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= METZ_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= METZ_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= METZ_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= METZ_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= METZ_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = METZ, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3453,8 +3476,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_METZ_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RADIO1_PROTOCOL == 1
-                    if (irmp_pulse_time >= RADIO1_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RADIO1_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= RADIO1_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RADIO1_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= RADIO1_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RADIO1_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= RADIO1_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RADIO1_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RADIO1, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3467,8 +3490,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RRADIO1_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RECS80_PROTOCOL == 1
-                    if (irmp_pulse_time >= RECS80_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RECS80_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= RECS80_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RECS80_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= RECS80_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RECS80_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= RECS80_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RECS80_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's RECS80
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RECS80, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3481,10 +3504,10 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RECS80_PROTOCOL == 1
 
 #if IRMP_SUPPORT_S100_PROTOCOL == 1
-                    if (((irmp_pulse_time >= S100_START_BIT_LEN_MIN     && irmp_pulse_time <= S100_START_BIT_LEN_MAX) ||
-                         (irmp_pulse_time >= 2 * S100_START_BIT_LEN_MIN && irmp_pulse_time <= 2 * S100_START_BIT_LEN_MAX)) &&
-                        ((irmp_pause_time >= S100_START_BIT_LEN_MIN     && irmp_pause_time <= S100_START_BIT_LEN_MAX) ||
-                         (irmp_pause_time >= 2 * S100_START_BIT_LEN_MIN && irmp_pause_time <= 2 * S100_START_BIT_LEN_MAX)))
+                    if (((ir->isr.pulse_time >= S100_START_BIT_LEN_MIN     && ir->isr.pulse_time <= S100_START_BIT_LEN_MAX) ||
+                         (ir->isr.pulse_time >= 2 * S100_START_BIT_LEN_MIN && ir->isr.pulse_time <= 2 * S100_START_BIT_LEN_MAX)) &&
+                        ((ir->isr.pause_time >= S100_START_BIT_LEN_MIN     && ir->isr.pause_time <= S100_START_BIT_LEN_MAX) ||
+                         (ir->isr.pause_time >= 2 * S100_START_BIT_LEN_MIN && ir->isr.pause_time <= 2 * S100_START_BIT_LEN_MAX)))
                     {                                                           // it's S100
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = S100, start bit timings: pulse: %3d - %3d, pause: %3d - %3d or pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3495,10 +3518,10 @@ irmp_ISR (void)
 #endif // ANALYZE
 
                         irmp_param_p = (IRMP_PARAMETER *) &s100_param;
-                        last_pause = irmp_pause_time;
+                        last_pause = ir->isr.pause_time;
 
-                        if ((irmp_pulse_time > S100_START_BIT_LEN_MAX && irmp_pulse_time <= 2 * S100_START_BIT_LEN_MAX) ||
-                            (irmp_pause_time > S100_START_BIT_LEN_MAX && irmp_pause_time <= 2 * S100_START_BIT_LEN_MAX))
+                        if ((ir->isr.pulse_time > S100_START_BIT_LEN_MAX && ir->isr.pulse_time <= 2 * S100_START_BIT_LEN_MAX) ||
+                            (ir->isr.pause_time > S100_START_BIT_LEN_MAX && ir->isr.pause_time <= 2 * S100_START_BIT_LEN_MAX))
                         {
                           last_value  = 0;
                           rc5_cmd_bit6 = 1<<6;
@@ -3512,14 +3535,14 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_S100_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1
-                    if (((irmp_pulse_time >= RC5_START_BIT_LEN_MIN     && irmp_pulse_time <= RC5_START_BIT_LEN_MAX) ||
-                         (irmp_pulse_time >= 2 * RC5_START_BIT_LEN_MIN && irmp_pulse_time <= 2 * RC5_START_BIT_LEN_MAX)) &&
-                        ((irmp_pause_time >= RC5_START_BIT_LEN_MIN     && irmp_pause_time <= RC5_START_BIT_LEN_MAX) ||
-                         (irmp_pause_time >= 2 * RC5_START_BIT_LEN_MIN && irmp_pause_time <= 2 * RC5_START_BIT_LEN_MAX)))
+                    if (((ir->isr.pulse_time >= RC5_START_BIT_LEN_MIN     && ir->isr.pulse_time <= RC5_START_BIT_LEN_MAX) ||
+                         (ir->isr.pulse_time >= 2 * RC5_START_BIT_LEN_MIN && ir->isr.pulse_time <= 2 * RC5_START_BIT_LEN_MAX)) &&
+                        ((ir->isr.pause_time >= RC5_START_BIT_LEN_MIN     && ir->isr.pause_time <= RC5_START_BIT_LEN_MAX) ||
+                         (ir->isr.pause_time >= 2 * RC5_START_BIT_LEN_MIN && ir->isr.pause_time <= 2 * RC5_START_BIT_LEN_MAX)))
                     {                                                           // it's RC5
 #if IRMP_SUPPORT_FDC_PROTOCOL == 1
-                        if (irmp_pulse_time >= FDC_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= FDC_START_BIT_PULSE_LEN_MAX &&
-                            irmp_pause_time >= FDC_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= FDC_START_BIT_PAUSE_LEN_MAX)
+                        if (ir->isr.pulse_time >= FDC_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= FDC_START_BIT_PULSE_LEN_MAX &&
+                            ir->isr.pause_time >= FDC_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= FDC_START_BIT_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("protocol = RC5 or FDC\n");
@@ -3530,14 +3553,14 @@ irmp_ISR (void)
                                             RC5_START_BIT_LEN_MIN, RC5_START_BIT_LEN_MAX,
                                             RC5_START_BIT_LEN_MIN, RC5_START_BIT_LEN_MAX);
 #endif // ANALYZE
-                            memcpy_P (&irmp_param2, &fdc_param, sizeof (IRMP_PARAMETER));
+                            memcpy_P (&irmp.param2, &fdc_param, sizeof (IRMP_PARAMETER));
                         }
                         else
 #endif // IRMP_SUPPORT_FDC_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RCCAR_PROTOCOL == 1
-                        if (irmp_pulse_time >= RCCAR_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RCCAR_START_BIT_PULSE_LEN_MAX &&
-                            irmp_pause_time >= RCCAR_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RCCAR_START_BIT_PAUSE_LEN_MAX)
+                        if (ir->isr.pulse_time >= RCCAR_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RCCAR_START_BIT_PULSE_LEN_MAX &&
+                            ir->isr.pause_time >= RCCAR_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RCCAR_START_BIT_PAUSE_LEN_MAX)
                         {
 #ifdef ANALYZE
                             ANALYZE_PRINTF ("protocol = RC5 or RCCAR\n");
@@ -3548,7 +3571,7 @@ irmp_ISR (void)
                                             RC5_START_BIT_LEN_MIN, RC5_START_BIT_LEN_MAX,
                                             RC5_START_BIT_LEN_MIN, RC5_START_BIT_LEN_MAX);
 #endif // ANALYZE
-                            memcpy_P (&irmp_param2, &rccar_param, sizeof (IRMP_PARAMETER));
+                            memcpy_P (&irmp.param2, &rccar_param, sizeof (IRMP_PARAMETER));
                         }
                         else
 #endif // IRMP_SUPPORT_RCCAR_PROTOCOL == 1
@@ -3563,10 +3586,10 @@ irmp_ISR (void)
                         }
 
                         irmp_param_p = (IRMP_PARAMETER *) &rc5_param;
-                        last_pause = irmp_pause_time;
+                        last_pause = ir->isr.pause_time;
 
-                        if ((irmp_pulse_time > RC5_START_BIT_LEN_MAX && irmp_pulse_time <= 2 * RC5_START_BIT_LEN_MAX) ||
-                            (irmp_pause_time > RC5_START_BIT_LEN_MAX && irmp_pause_time <= 2 * RC5_START_BIT_LEN_MAX))
+                        if ((ir->isr.pulse_time > RC5_START_BIT_LEN_MAX && ir->isr.pulse_time <= 2 * RC5_START_BIT_LEN_MAX) ||
+                            (ir->isr.pause_time > RC5_START_BIT_LEN_MAX && ir->isr.pause_time <= 2 * RC5_START_BIT_LEN_MAX))
                         {
                             last_value  = 0;
                             rc5_cmd_bit6 = 1<<6;
@@ -3580,8 +3603,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RC5_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RCII_PROTOCOL == 1
-                    if ((irmp_pulse_time >= RCII_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RCII_START_BIT_PULSE_LEN_MAX) &&
-                        (irmp_pause_time >= RCII_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RCII_START_BIT_PAUSE_LEN_MAX))
+                    if ((ir->isr.pulse_time >= RCII_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RCII_START_BIT_PULSE_LEN_MAX) &&
+                        (ir->isr.pause_time >= RCII_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RCII_START_BIT_PAUSE_LEN_MAX))
                     {                                                           // it's RCII
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RCII, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3589,7 +3612,7 @@ irmp_ISR (void)
                                         RCII_START_BIT_PAUSE_LEN_MIN, RCII_START_BIT_PAUSE_LEN_MAX)
 #endif // ANALYZE
                         irmp_param_p = (IRMP_PARAMETER *) &rcii_param;
-                        last_pause = irmp_pause_time;
+                        last_pause = ir->isr.pause_time;
                         waiting_for_2nd_pulse = 1;
                         last_value  = 1;
                     }
@@ -3597,9 +3620,9 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RCII_PROTOCOL == 1
 
 #if IRMP_SUPPORT_DENON_PROTOCOL == 1
-                    if ( (irmp_pulse_time >= DENON_PULSE_LEN_MIN && irmp_pulse_time <= DENON_PULSE_LEN_MAX) &&
-                        ((irmp_pause_time >= DENON_1_PAUSE_LEN_MIN && irmp_pause_time <= DENON_1_PAUSE_LEN_MAX) ||
-                         (irmp_pause_time >= DENON_0_PAUSE_LEN_MIN && irmp_pause_time <= DENON_0_PAUSE_LEN_MAX)))
+                    if ( (ir->isr.pulse_time >= DENON_PULSE_LEN_MIN && ir->isr.pulse_time <= DENON_PULSE_LEN_MAX) &&
+                        ((ir->isr.pause_time >= DENON_1_PAUSE_LEN_MIN && ir->isr.pause_time <= DENON_1_PAUSE_LEN_MAX) ||
+                         (ir->isr.pause_time >= DENON_0_PAUSE_LEN_MIN && ir->isr.pause_time <= DENON_0_PAUSE_LEN_MAX)))
                     {                                                           // it's DENON
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = DENON, start bit timings: pulse: %3d - %3d, pause: %3d - %3d or %3d - %3d\n",
@@ -3613,9 +3636,9 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_DENON_PROTOCOL == 1
 
 #if IRMP_SUPPORT_THOMSON_PROTOCOL == 1
-                    if ( (irmp_pulse_time >= THOMSON_PULSE_LEN_MIN && irmp_pulse_time <= THOMSON_PULSE_LEN_MAX) &&
-                        ((irmp_pause_time >= THOMSON_1_PAUSE_LEN_MIN && irmp_pause_time <= THOMSON_1_PAUSE_LEN_MAX) ||
-                         (irmp_pause_time >= THOMSON_0_PAUSE_LEN_MIN && irmp_pause_time <= THOMSON_0_PAUSE_LEN_MAX)))
+                    if ( (ir->isr.pulse_time >= THOMSON_PULSE_LEN_MIN && ir->isr.pulse_time <= THOMSON_PULSE_LEN_MAX) &&
+                        ((ir->isr.pause_time >= THOMSON_1_PAUSE_LEN_MIN && ir->isr.pause_time <= THOMSON_1_PAUSE_LEN_MAX) ||
+                         (ir->isr.pause_time >= THOMSON_0_PAUSE_LEN_MIN && ir->isr.pause_time <= THOMSON_0_PAUSE_LEN_MAX)))
                     {                                                           // it's THOMSON
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = THOMSON, start bit timings: pulse: %3d - %3d, pause: %3d - %3d or %3d - %3d\n",
@@ -3629,8 +3652,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_THOMSON_PROTOCOL == 1
 
 #if IRMP_SUPPORT_BOSE_PROTOCOL == 1
-                    if (irmp_pulse_time >= BOSE_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= BOSE_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= BOSE_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= BOSE_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= BOSE_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= BOSE_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= BOSE_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= BOSE_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = BOSE, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3643,8 +3666,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_BOSE_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RC6_PROTOCOL == 1
-                    if (irmp_pulse_time >= RC6_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RC6_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= RC6_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RC6_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= RC6_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RC6_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= RC6_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RC6_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's RC6
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RC6, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3659,8 +3682,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RC6_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RECS80EXT_PROTOCOL == 1
-                    if (irmp_pulse_time >= RECS80EXT_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RECS80EXT_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= RECS80EXT_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RECS80EXT_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= RECS80EXT_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RECS80EXT_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= RECS80EXT_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RECS80EXT_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's RECS80EXT
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RECS80EXT, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3673,8 +3696,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RECS80EXT_PROTOCOL == 1
 
 #if IRMP_SUPPORT_NUBERT_PROTOCOL == 1
-                    if (irmp_pulse_time >= NUBERT_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= NUBERT_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= NUBERT_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= NUBERT_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= NUBERT_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= NUBERT_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= NUBERT_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= NUBERT_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's NUBERT
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = NUBERT, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3687,8 +3710,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_NUBERT_PROTOCOL == 1
 
 #if IRMP_SUPPORT_FAN_PROTOCOL == 1
-                    if (irmp_pulse_time >= FAN_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= FAN_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= FAN_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= FAN_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= FAN_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= FAN_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= FAN_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= FAN_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's FAN
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = FAN, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3701,8 +3724,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_FAN_PROTOCOL == 1
 
 #if IRMP_SUPPORT_SPEAKER_PROTOCOL == 1
-                    if (irmp_pulse_time >= SPEAKER_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= SPEAKER_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= SPEAKER_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= SPEAKER_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= SPEAKER_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= SPEAKER_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= SPEAKER_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= SPEAKER_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's SPEAKER
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = SPEAKER, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3715,8 +3738,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_SPEAKER_PROTOCOL == 1
 
 #if IRMP_SUPPORT_BANG_OLUFSEN_PROTOCOL == 1
-                    if (irmp_pulse_time >= BANG_OLUFSEN_START_BIT1_PULSE_LEN_MIN && irmp_pulse_time <= BANG_OLUFSEN_START_BIT1_PULSE_LEN_MAX &&
-                        irmp_pause_time >= BANG_OLUFSEN_START_BIT1_PAUSE_LEN_MIN && irmp_pause_time <= BANG_OLUFSEN_START_BIT1_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= BANG_OLUFSEN_START_BIT1_PULSE_LEN_MIN && ir->isr.pulse_time <= BANG_OLUFSEN_START_BIT1_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= BANG_OLUFSEN_START_BIT1_PAUSE_LEN_MIN && ir->isr.pause_time <= BANG_OLUFSEN_START_BIT1_PAUSE_LEN_MAX)
                     {                                                           // it's BANG_OLUFSEN
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = BANG_OLUFSEN\n");
@@ -3740,8 +3763,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_BANG_OLUFSEN_PROTOCOL == 1
 
 #if IRMP_SUPPORT_GRUNDIG_NOKIA_IR60_PROTOCOL == 1
-                    if (irmp_pulse_time >= GRUNDIG_NOKIA_IR60_START_BIT_LEN_MIN && irmp_pulse_time <= GRUNDIG_NOKIA_IR60_START_BIT_LEN_MAX &&
-                        irmp_pause_time >= GRUNDIG_NOKIA_IR60_PRE_PAUSE_LEN_MIN && irmp_pause_time <= GRUNDIG_NOKIA_IR60_PRE_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= GRUNDIG_NOKIA_IR60_START_BIT_LEN_MIN && ir->isr.pulse_time <= GRUNDIG_NOKIA_IR60_START_BIT_LEN_MAX &&
+                        ir->isr.pause_time >= GRUNDIG_NOKIA_IR60_PRE_PAUSE_LEN_MIN && ir->isr.pause_time <= GRUNDIG_NOKIA_IR60_PRE_PAUSE_LEN_MAX)
                     {                                                           // it's GRUNDIG
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = GRUNDIG, pre bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3749,15 +3772,15 @@ irmp_ISR (void)
                                         GRUNDIG_NOKIA_IR60_PRE_PAUSE_LEN_MIN, GRUNDIG_NOKIA_IR60_PRE_PAUSE_LEN_MAX);
 #endif // ANALYZE
                         irmp_param_p = (IRMP_PARAMETER *) &grundig_param;
-                        last_pause = irmp_pause_time;
+                        last_pause = ir->isr.pause_time;
                         last_value  = 1;
                     }
                     else
 #endif // IRMP_SUPPORT_GRUNDIG_NOKIA_IR60_PROTOCOL == 1
 
 #if IRMP_SUPPORT_MERLIN_PROTOCOL == 1 // check MERLIN before RUWIDO!
-                    if (irmp_pulse_time >= MERLIN_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= MERLIN_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= MERLIN_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= MERLIN_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= MERLIN_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= MERLIN_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= MERLIN_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= MERLIN_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's MERLIN
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = MERLIN, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3765,17 +3788,17 @@ irmp_ISR (void)
                                         MERLIN_START_BIT_PAUSE_LEN_MIN, MERLIN_START_BIT_PAUSE_LEN_MAX);
 #endif // ANALYZE
                         irmp_param_p = (IRMP_PARAMETER *) &merlin_param;
-                        last_pause = irmp_pause_time;
+                        last_pause = ir->isr.pause_time;
                         last_value = 1;
                     }
                     else
 #endif // IRMP_SUPPORT_MERLIN_PROTOCOL == 1
 
 #if IRMP_SUPPORT_SIEMENS_OR_RUWIDO_PROTOCOL == 1
-                    if (((irmp_pulse_time >= SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MAX) ||
-                         (irmp_pulse_time >= 2 * SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= 2 * SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MAX)) &&
-                        ((irmp_pause_time >= SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MAX) ||
-                         (irmp_pause_time >= 2 * SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= 2 * SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MAX)))
+                    if (((ir->isr.pulse_time >= SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MAX) ||
+                         (ir->isr.pulse_time >= 2 * SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= 2 * SIEMENS_OR_RUWIDO_START_BIT_PULSE_LEN_MAX)) &&
+                        ((ir->isr.pause_time >= SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MAX) ||
+                         (ir->isr.pause_time >= 2 * SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= 2 * SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MAX)))
                     {                                                           // it's RUWIDO or SIEMENS
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RUWIDO, start bit timings: pulse: %3d - %3d or %3d - %3d, pause: %3d - %3d or %3d - %3d\n",
@@ -3785,15 +3808,15 @@ irmp_ISR (void)
                                         2 * SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MIN, 2 * SIEMENS_OR_RUWIDO_START_BIT_PAUSE_LEN_MAX);
 #endif // ANALYZE
                         irmp_param_p = (IRMP_PARAMETER *) &ruwido_param;
-                        last_pause = irmp_pause_time;
+                        last_pause = ir->isr.pause_time;
                         last_value  = 1;
                     }
                     else
 #endif // IRMP_SUPPORT_SIEMENS_OR_RUWIDO_PROTOCOL == 1
 
 #if IRMP_SUPPORT_FDC_PROTOCOL == 1
-                    if (irmp_pulse_time >= FDC_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= FDC_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= FDC_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= FDC_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= FDC_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= FDC_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= FDC_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= FDC_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = FDC, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3806,8 +3829,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_FDC_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RCCAR_PROTOCOL == 1
-                    if (irmp_pulse_time >= RCCAR_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= RCCAR_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= RCCAR_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= RCCAR_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= RCCAR_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= RCCAR_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= RCCAR_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= RCCAR_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = RCCAR, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3820,8 +3843,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RCCAR_PROTOCOL == 1
 
 #if IRMP_SUPPORT_KATHREIN_PROTOCOL == 1
-                    if (irmp_pulse_time >= KATHREIN_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= KATHREIN_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= KATHREIN_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= KATHREIN_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= KATHREIN_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= KATHREIN_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= KATHREIN_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= KATHREIN_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's KATHREIN
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = KATHREIN, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3834,8 +3857,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_KATHREIN_PROTOCOL == 1
 
 #if IRMP_SUPPORT_NETBOX_PROTOCOL == 1
-                    if (irmp_pulse_time >= NETBOX_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= NETBOX_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= NETBOX_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= NETBOX_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= NETBOX_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= NETBOX_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= NETBOX_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= NETBOX_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's NETBOX
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = NETBOX, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3848,8 +3871,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_NETBOX_PROTOCOL == 1
 
 #if IRMP_SUPPORT_LEGO_PROTOCOL == 1
-                    if (irmp_pulse_time >= LEGO_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= LEGO_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= LEGO_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= LEGO_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= LEGO_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= LEGO_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= LEGO_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= LEGO_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = LEGO, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3862,8 +3885,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_LEGO_PROTOCOL == 1
 
 #if IRMP_SUPPORT_IRMP16_PROTOCOL == 1
-                    if (irmp_pulse_time >= IRMP16_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= IRMP16_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= IRMP16_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= IRMP16_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= IRMP16_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= IRMP16_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= IRMP16_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= IRMP16_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = IRMP16, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3876,8 +3899,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_IRMP16_PROTOCOL == 1
 
 #if IRMP_SUPPORT_GREE_PROTOCOL == 1
-                    if (irmp_pulse_time >= GREE_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= GREE_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= GREE_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= GREE_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= GREE_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= GREE_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= GREE_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= GREE_START_BIT_PAUSE_LEN_MAX)
                     {
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = GREE, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3890,8 +3913,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_GREE_PROTOCOL == 1
 
 #if IRMP_SUPPORT_A1TVBOX_PROTOCOL == 1
-                    if (irmp_pulse_time >= A1TVBOX_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= A1TVBOX_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= A1TVBOX_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= A1TVBOX_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= A1TVBOX_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= A1TVBOX_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= A1TVBOX_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= A1TVBOX_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's A1TVBOX
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = A1TVBOX, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
@@ -3906,8 +3929,8 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_A1TVBOX_PROTOCOL == 1
 
 #if IRMP_SUPPORT_ORTEK_PROTOCOL == 1
-                    if (irmp_pulse_time >= ORTEK_START_BIT_PULSE_LEN_MIN && irmp_pulse_time <= ORTEK_START_BIT_PULSE_LEN_MAX &&
-                        irmp_pause_time >= ORTEK_START_BIT_PAUSE_LEN_MIN && irmp_pause_time <= ORTEK_START_BIT_PAUSE_LEN_MAX)
+                    if (ir->isr.pulse_time >= ORTEK_START_BIT_PULSE_LEN_MIN && ir->isr.pulse_time <= ORTEK_START_BIT_PULSE_LEN_MAX &&
+                        ir->isr.pause_time >= ORTEK_START_BIT_PAUSE_LEN_MIN && ir->isr.pause_time <= ORTEK_START_BIT_PAUSE_LEN_MAX)
                     {                                                           // it's ORTEK (Hama)
 #ifdef ANALYZE
                         ANALYZE_PRINTF ("protocol = ORTEK, start bit timings: pulse: %3d - %3d, pause: %3d - %3d\n",
